// -------------------------------
// Copyright  2007 Andreas Brsen
// -------------------------------

#include "LegacyCode.h"
#include "atlstr.h"

using namespace Legacy;

/// <summary>
/// Constructor.
/// </summary>
LegacyCode::LegacyCode(void)
{
}

/// <summary>
/// Destructor.
/// </summary>
LegacyCode::~LegacyCode(void)
{
}

/// <summary>
/// Method, which represents the functionalty of the legacy code.
/// </summary>
/// <param name="pLegacyCodeCallbackContainer">
/// The container of the callback methods, which have to be used to get the necessary 
/// information to execute the functionality.
/// </param>
/// <returns>
/// The created string, based on the functionality of the legacy code.
/// </returns>
LPTSTR LegacyCode::StartLegacyCode( LegacyCodeCallbackContainer* pLegacyCodeCallbackContainer )
{
   // Get resource strings via the callback mechanism and concatenate them based on the enum values.
   // ----------------------------------------------------------------------------------------------
   
   long resourceNumberForEnumValue;
   int existsResource;
   existsResource = 0;

   // Get for the given enum value the appropriate number, which is used to get a resource string.
   resourceNumberForEnumValue = 
      pLegacyCodeCallbackContainer
         ->DoSomethingWithAEnumValueUnmanagedCallback( ValueOne );

   // Get the resource string.
   // ------------------------
   CString resourceString1;
   resourceString1 = 
      pLegacyCodeCallbackContainer
         ->LoadStringOutOfResourceUnmanagedCallback( resourceNumberForEnumValue, existsResource );

   // Get for the given enum value the appropriate number, which is used to get a resource string.
   resourceNumberForEnumValue = 
      pLegacyCodeCallbackContainer
         ->DoSomethingWithAEnumValueUnmanagedCallback( ValueTwo );

   // Get the resource string.
   // ------------------------
   CString resourceString2;
   resourceString2 = 
      pLegacyCodeCallbackContainer->LoadStringOutOfResourceUnmanagedCallback( 321, existsResource );

   // Concatenate the both strings (Not a really high sofisticated logic - Sorry ;o)
   // ------------------------------------------------------------------------------
   CString buildUpString;
   buildUpString = resourceString1 + ";" + resourceString2;
 
   // Build up the return value.
   // --------------------------
   int sizeOfBuildUpString;
   sizeOfBuildUpString = buildUpString.GetLength() + 1;

   LPTSTR returnValue;
   returnValue = new TCHAR[ sizeOfBuildUpString ];
   _tcscpy_s( returnValue, sizeOfBuildUpString, buildUpString );

   return( returnValue );
}