// -------------------------------
// Copyright  2007 Andreas Brsen
// -------------------------------

#ifndef _LEGACYCODECALLBACKS_H_
#define _LEGACYCODECALLBACKS_H_

#if _MSC_VER > 1000
#pragma once
#endif

#include "LegacyCodeEnum.h"
#include <windows.h>

namespace Legacy
{
   /// <summary>
   /// Class, which contains the native C++ Callbacks, which are used inside the legacy code.
   /// </summary>
   class LegacyCodeCallbacks
   {
      public:

      /// <summary>
      /// Get a string out of the resources.
      /// </summary>
      /// <param name="resourceId">
      /// The resource Id.
      /// </param>
      /// <param name="resourceExistsReturnValue">
      /// The value, which indicate, whether a string exists for the given resource 
      /// ID (!=0) or not (0)
      /// </param>
      /// <returns>
      /// The found string or null, if no string exists for the given resource Id.
      /// </returns>
      typedef LPTSTR (__stdcall *LoadStringOutOfResourceUnmanagedCallback)
      ( 
         long resourceId, 
         int& resourceExistsReturnValue 
      );

      /// <summary>
      /// This delegate delivers for a given enum the appropriate Int32 value.
      /// </summary>
      /// <param name="managedEnum">
      /// The enum value.
      /// </param>
      /// <returns>
      /// The appropriate long value for the given enum.
      /// </returns>
      typedef long (__stdcall *DoSomethingWithAEnumValueUnmanagedCallback)
      (
         LegacyCodeEnum legacyCodeEnum
      );
   };
};
#endif